#
# makefile integratedTDC code
#

MCU = atmega328p

F_OSC = 8000000

CFLAGS = -g -O2 -mmcu=$(MCU) -DF_CPU=$(F_OSC)

LDFLAGS = -g -Wl,-Map=$(<:.o=.map),--cref -mmcu=$(MCU)

DUDEPORT  = -c avrispmkII -P usb
DUDEMCU = atmega328p
AVRDUDE  = avrdude $(DUDEPORT) -p $(DUDEMCU) 

OBJECTS = utils.o UART_funcs.o SPI_cmds.o cmds.o NeoPixel.o

LIST =  main.lst

.PHONEY : fuses flash init clean

all: main.hex $(LIST)

clean:
	rm -f *.o *~ *.hex *.elf *.map *.lst

init: fuses flash

fuses: 
	$(AVRDUDE) -U lfuse:w:0xe2:m -U hfuse:w:0xd9:m

flash: main.hex
	$(AVRDUDE) -U flash:w:$<:i

$(LIST) : main.elf
	avr-objdump -h -S $< > $@
	avr-size --common -d $<

%.o: %.c
	avr-g++ -c $(CFLAGS) $< -o $@

main.elf: main.o  $(OBJECTS)
	avr-g++ $(LDFLAGS) $^ -o $@

main.hex: main.elf
	avr-objcopy -j .text -j .data -O ihex $< $@
